;Tip1745A: SOL_SPRING.LSP   Solid spring          (c)2001, Bill Zondlo

                                ;program to get main entity name of polyline made
                                ;from 3dspiral.lsp and inserts circle or polygon
                                ;at vertices, extudes, joins all segments if desired.
                                ;to create solid model spring along polyline.
;---
;globalization and small fixes 1/2004 by Xanadu - www.xanadu.cz
;(switch off OSMODE when generating springs)
;-------------------------------;
;-------------------------------;
(defun myerror (s)                  ;error trap
  (if (/= s "Abbruch")
     (princ (strcat "\nError: " s))
)
  (setvar "cmdecho" ocmd)           ;resets error & cmdecho should
  (setvar "ucsicon" oucsi)
  (setvar "blipmode" oblp)
  (setq *error* olderr)             ;an error occur during the program
   (princ)
)
;-------------------------------;
(defun c:sol_spring (/ ang ans1 ans2 ans3 cnt d1 dist ds1 ds2 dvan e e1 elst en1 en2
                       lc1 lc2 l1 myerror oblp ocmd olderr oucsi plst1 plst2 pl1 sd1 ss vx1 vx2)
  (setq olderr *error*
        *error* myerror)
  (setq ocmd (getvar "cmdecho"))    ;gets current error trap and variables
  (setq oblp (getvar "blipmode"))
  (setq oucsi (getvar "ucsicon")
  )
 (setvar "cmdecho" 0)
 (command "_.undo" "_BE")             ;to group for undo.
   (initget 1 "Rund Eckig Objekt")
   (setq ans1 (getkword "\nFederquerschnitt [Rund/Eckig/Objekt auswaehlen]: ")
    )
   (cond ((equal ans1 "Rund")
          (initget 7)
           (setq d1 (getdist "\nDrahtdurchmesser: "))
              )
         ((equal ans1 "Eckig")
          (initget 7)
           (setq d1 (getdist "\nDrahtdurchmesser: "))          
              )
         ((equal ans1 "Objekt")
         (initget 7)
          (setq Objekt1(car (entsel "\nWaehle Objekt<pick>: ")))    ;select Region         
              )              
         )        ;end cond                       
 (setq e 1)
 (while e
  (setq pl1 (car (entsel "\nWaehle 3D-Spirale <pick>: ")))    ;select polyline
   (if (or (null pl1)                                          ;if missed pick
           (/= (cdr (assoc 0 (entget pl1))) "POLYLINE")        ;if not a 3d spiral
           (/= (cdr (assoc 70 (entget pl1))) 8))                                          
             (prompt "\nObjekt ist keine Spirale.")
             (setq e nil)
         )                  ;end if
   )                        ;end while
 (setvar "blipmode" 0)
 (setvar "ucsicon" 0)
;-----------------------------;
 (if (setq e1 (entnext pl1))
     (progn
      (setq l1 (list e1))
       (while (and (setq e1 (entnext e1))                ;while entities follow.
              (/= (cdr (assoc 0 (entget e1))) "SEQEND")) ;stop at "seqend".
           (setq l1 (append l1 (list e1)))               ;creates list of polyline vertex.
            )                              ;end while
      )                                    ;end progn
    )                                      ;end if.
;-----------------------------;     
(setq dist 0                  ;initialize values
      cnt 0
   )
;-----------------------------;
(cond ((equal ans1 "Rund")
  (repeat (1- (length l1))                               ;
   (setq vx1 (nth cnt l1)                                ;vertex entname in order of list
         lc1 (trans (cdr (assoc 10 (entget vx1))) vx1 1) ;point coordinate of vertex
         vx2 (nth (1+ cnt) l1)                           ;next vertex
         lc2 (trans (cdr (assoc 10 (entget vx2))) vx2 1) ;point coord.
         ds1 (distance lc1 lc2)                          ;length of line segments
         dist (+ dist ds1)                               ;total length of spring
         cnt (1+ cnt)
      ) 
   (command "_ucs" "_za" lc1 lc2 )                         ;sets ucs z axis to polyline segments
   (command "_.circle" "0,0,0" "_d" d1)                   ;draws circle at vertext.
   (command "_.extrude" (entlast) "" (+ ds1 0.5) 0)      ;solid model.
   (setq elst (append elst (list (entlast))) 
         plst1 (append plst1 (list lc1))
         plst2 (append plst2 (list lc2))
    )
   (command "_.ucs" "_p")
    )                                                    ;end repeat
   (entdel pl1)                                          ;deletes pline.
       )                                                 ;end list.
;--------------------------------------------------------;
     ((equal ans1 "Eckig")
   (repeat (1- (length l1))                              ;
   (setq vx1 (nth cnt l1)                                ;vertex in order of list
         lc1 (cdr (assoc 10 (entget vx1)))               ;point coordinate of vertex
         vx2 (nth (1+ cnt) l1)                           ;next vertex
         lc2 (cdr (assoc 10 (entget vx2)))               ;point coordinate of next vertex
         ds1 (distance lc1 lc2)                          ;length of line segments
         dist (+ dist ds1)                               ;total length of spring
         cnt (1+ cnt)
         lc1 (trans lc1 0 1)
         lc2 (trans lc2 0 1)
         )  
;--------------------------------------------------------;
     ((equal ans1 "Objekt")
         lc1 (cdr (assoc 10 (entget vx1)))               ;point coordinate of vertex
         vx2 (nth (1+ cnt) l1)                           ;next vertex
         lc2 (cdr (assoc 10 (entget vx2)))               ;point coordinate of next vertex
         ds1 (distance lc1 lc2)                          ;length of line segments
         dist (+ dist ds1)                               ;total length of spring
         cnt (1+ cnt)
         lc1 (trans lc1 0 1)
         lc2 (trans lc2 0 1)
         )           
   (command "_ucs" "_za" lc1 lc2 )                         ;sets ucs z axis to polyline segments
   (command "_.polygon" 4 (list 0 0 0) "_c" (/ d1 2.0))   ;draws polygon at vertext.
   (command "_.extrude" (entlast) "" (+ ds1 0.5) 0)      ;solid model.
   (setq elst (append elst (list (entlast))) 
         plst1 (append plst1 (list lc1))
         plst2 (append plst2 (list lc2))
    )
   (command "_ucs" "_p")
    )                                                    ;end repeat
   (entdel pl1)                                          ;deletes pline.
  )                                                      ;end list.                                                  
)                                                        ;end cond
;-------------------------------------;;
(setq cnt 0
      ss (ssadd))
(repeat (1- (length elst))
 (setq en1 (nth cnt elst)
       en2 (nth (1+ cnt) elst)
       sd1 (nth cnt plst1)
       lc1 (nth (1+ cnt) plst1)
       lc2 (nth (1+ cnt) plst2)
       cnt (1+ cnt)
  )
 (command "_.ucs" "_za" (trans lc1 en2 1)(trans lc2 en2 1))
 (command "_.slice" en1 "" "_xy" (trans lc1 en2 1)(trans sd1 en1 1))
 (ssadd en1 ss)
 (command "_ucs" "_p")
)
 (ssadd (last elst) ss)
;-------------------------------------;;
(initget "Ja Nein")
 (setq ans2 (getkword "\nAlle Segmente verbinden[Ja/<Nein>]: "))
  (cond ((= ans2 "Ja")
  (command "_.union" ss "")                             ;joins segments if desired.
   )
)
;-------------------------------------;  
    (redraw)  
    (princ (strcat "\nLength of Spring is: " (rtos dist) " units.")) ;combined length of pline segments.
    (command "_.undo" "_E")                               ;
    (setvar "cmdecho" ocmd)                              ;resets cmdecho and error
    (setvar "ucsicon" oucsi)
    (setvar "blipmode" oblp)
    (setq *error* olderr)
       (princ)
)